unit uPluginPresupuestosCliente;

interface

uses
  uModuleController, uInterfaces, uHostManager, Menus, Classes, ActnList,
  ImgList, Controls, PngImageList, uPlugins_Intf;

type
  TPluginPresupuestosCliente = class(TModuleController, IMCPresupuestosCliente)
    actPresupuestosCliente: TAction;
    ExtraImages: TPngImageList;
    LargeImages: TPngImageList;
    MainMenu: TMainMenu;
    ModuleActionList: TActionList;
    SmallImages: TPngImageList;
    Ventas1: TMenuItem;
    PresupuestosdeCliente1: TMenuItem;
    actInfPresupuestos: TAction;
    procedure actPresupuestosClienteExecute(Sender: TObject);
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;

    procedure VerPresupuestos(const ID_Cliente: Integer;
      const ANombreCliente : String = '');
  end;

implementation

{$R *.dfm}

uses
  Forms, Dialogs, SysUtils, cxControls,
  uPresupuestosClienteController, uBizPresupuestosCliente, uPresupuestosClienteViewRegister;

function GetModule : TModuleController;
begin
  Result := TPluginPresupuestosCliente.Create(NIL);
end;

exports
  GetModule name GET_MODULE_FUNC;

procedure TPluginPresupuestosCliente.actPresupuestosClienteExecute(Sender: TObject);
var
  APresupuestosClienteController : IPresupuestosClienteController;
  APresupuestosCliente : IBizPresupuestoCliente;

begin
  APresupuestosClienteController := TPresupuestosClienteController.Create;
  APresupuestosCliente := APresupuestosClienteController.BuscarTodos;
  APresupuestosClienteController.VerTodos(APresupuestosCliente);
end;

constructor TPluginPresupuestosCliente.Create(AOwner: TComponent);
begin
  inherited;
  ModuleName := MODULENAME_PRESUPUESTOS_CLIENTE;
  uPresupuestosClienteViewRegister.RegisterViews;
end;

destructor TPluginPresupuestosCliente.Destroy;
begin
  uPresupuestosClienteViewRegister.UnregisterViews;
  inherited;
end;

procedure TPluginPresupuestosCliente.VerPresupuestos(const ID_Cliente: Integer;
  const ANombreCliente : String = '');
var
  APresupuestosClienteController : IPresupuestosClienteController;
  APresupuestosCliente : IBizPresupuestoCliente;
  AText : String;
begin
  AText := Format('Lista de presupuestos del cliente %s', [ANombreCliente]);
  APresupuestosClienteController := TPresupuestosClienteController.Create;
  try
    ShowHourglassCursor;
    try
      APresupuestosCliente := APresupuestosClienteController.BuscarTodos(ID_Cliente);      
    finally
      HideHourglassCursor;
    end;
    APresupuestosClienteController.VerTodos(APresupuestosCliente, True, AText);
  finally
    APresupuestosCliente := NIL;
    APresupuestosClienteController := NIL;
  end;
end;

initialization
  RegisterModuleClass(TPluginPresupuestosCliente);

finalization
  UnRegisterModuleClass(TPluginPresupuestosCliente);

end.
